def getDirs(vector):
	return map(lambda v: v[0], vector)



class base_rune:
	def __init__(self):
		self.name = "base"
		self.dirs = []
		self.centerSeg1 = -1
		self.centerSeg2 = -1

	def getScore(self, vector):
		return 1.0 * (getDirs(vector) == self.dirs)
	
	def getCenter(self, vector):
		ax, ay = vector[self.centerSeg1][2] # az adott szegmens vegenek pozicioja
		bx, by = vector[self.centerSeg2][2]
		return ((ax+bx)*0.5, (ay+by)*0.5)
	
	def getName(self): return self.name


class __rune__time(base_rune):
	
	def __init__(self):
		base_rune.__init__(self)
		self.name = "time"
		self.dirs = [ [1,0], [-1,-1], [1,0], [-1, 1] ]
		self.centerSeg1 = 0
		self.centerSeg2 = 1

class __rune__triangle(base_rune):
	
	def __init__(self):
		base_rune.__init__(self)
		self.name = "triangle"
		self.dirs = [ [-1,-1], [1,0], [-1,1] ]
	
	def getCenter(self, vector):
		cx, cy = 0, 0
		for i in xrange(3):
			cx += vector[i][2][0]
			cy += vector[i][2][1]
		cx /= 3.0
		cy /= 3.0
		return (cx, cy)
		

class __rune__box(base_rune):
	
	def __init__(self):
		base_rune.__init__(self)
		self.name = "box"
		self.dirs = [ [0,-1], [1,0], [0,1], [-1, 0] ]
		self.centerSeg1 = 0
		self.centerSeg2 = 2


class __rune__lightning(base_rune):
	
	def __init__(self):
		base_rune.__init__(self)
		self.name = "lightning"
		self.dirs = [ [1,0], [-1,-1], [1,0], [-1,-1] ]
		
